/************************************************
 * soubor dedi-min-pole.cpp
 * mnohotvrnost a objekty td sekundy a minuty
 * pi tisku, vasn a pozdn vazba
 ************************************************/

#include <iostream>
#include <iomanip>

using namespace std;

const int MEZ_S = 60;

class sekundy {
	int s;
  public:
	sekundy() {s = 0;}
	sekundy(int pocatek) {s = pocatek;}
	virtual ~sekundy() {cout << "~sekundy(), "; tiskni();}
	int dej_s() {return s;}
	int nastav_s(int hodnota) {return s = hodnota;}
	virtual void zvys() {s++; }
	virtual void sniz() {
		if (s > 0) s--;
	}
	virtual void tiskni();
}; // class sekundy

ostream& operator << (ostream& os, sekundy& s) {
	os << setw(2) << setfill('0') << s.dej_s();
	return os;
}

void sekundy::tiskni() {
		cout << *this << endl;
	}
// konec tdy sekundy

class minuty : public sekundy {
	int m;
	void kontrola_uprava() {
		int pomocna;
		if ((pomocna = dej_s()) >= MEZ_S) {
			nastav_s(pomocna % MEZ_S);
			m += pomocna / MEZ_S;
		} else if (pomocna < 0) {
			nastav_s(pomocna % MEZ_S);
			m -= pomocna / MEZ_S;
		}
	} // void kontrola_uprava()
public:
	minuty(int se) : sekundy(se), m(0) {kontrola_uprava();}
	minuty(int mi = 0, int se = 0) : sekundy(se), m(mi) {
		kontrola_uprava();}
	virtual ~minuty() {cout << "~minuty(), "; tiskni();}
	virtual void zvys() {
		sekundy::zvys();
		kontrola_uprava();
	}
	virtual void sniz() {
		if (dej_s() == 0) {
			if (m > 0) {
				m--;
				nastav_s(MEZ_S);
			} 
		}
		sekundy::sniz();
		kontrola_uprava();
	}
	int dej_m() {return m;}
	virtual void tiskni();
}; // class minuty

ostream& operator << (ostream& os, minuty& m) {
	os << "mm.ss "<< setw(2) << setfill('0') << m.dej_m() 
	   << '.' << setw(2) << setfill('0') << m.dej_s();
	return os;
}

void minuty::tiskni() {
		cout << *this << endl;
	}
// konec tdy minuty

int main() {
	minuty m(12, 34);
	cout << m << endl;
	int i, j;

	sekundy *pole[5];
	pole[0] = new sekundy();
	pole[1] = new sekundy(1);
	pole[2] = new minuty(23, 00);
	pole[3] = new sekundy(45);
	pole[4] = new minuty(00, 67);

	for (j = 0; j < 5; j++) {
		for (i = 0; i < 100; i++)
			pole[j]->zvys();
	} // forall zvys()

	cout << "--------- tisk pole" << endl;
	for (j = 0; j < 5; j++) {
//		cout << *pole[j] << endl;
		pole[j]->tiskni();
	} // forall tiskni()
	cout << "--------- konec tisku" << endl;
	for (j = 0; j < 5; j++) {
		delete pole[j];
	}
	cout << "--------- konec ruseni" << endl;
    return 0;
} // int main()