/***********************************
 * soubor strof-HTML-tab.cpp
 * vytvo HTML soubor tabulkou
 * hodnot x a funkc sin(x) a cos(x)
 ***********************************/

#include <iostream>
#include <fstream>
#include <string>
#include <cmath>

using namespace std;

//const double M_PI = 3.1415926536;
char *jmeno_souboru = "tabelace";
string pripona = ".html";

string TABzacatek = 
  "<table width=\"100%\">"
  "\n\t<tr><td width=\"33%\">x</td>"
  "\n\t<td width=\"33%\">sin(x)</td>"
  "\n\t<td width=\"33%\">cos(x)</td></tr>";
string TABkonec = "</table>";

char *HTMLzacatek = 
  "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">"
  "<META http-equiv=Content-Type content=\"text/html; charset=windows-1250\">"
  "<HTML>"
  "<head> <title>Tabulka vytvoen v C++</title>"
  "</head>"
  "<body>";
char *HTMLkonec = "</body></html>";

/**************************************/
class oHTMLsoub : public ofstream {
public:
  oHTMLsoub(char *f) : ofstream((string(f)+pripona).c_str()){
	*this << HTMLzacatek << endl;
  }
  ~oHTMLsoub() {
	*this << HTMLkonec;
	this->close();
  }
}; // class oHTMLsoub : public ofstream

/**************************************/
int main() {
  double od = 0.0, po, rad;

  oHTMLsoub stabulka(jmeno_souboru);
//  ostream stabulka = cout;
  cout << "zadej do kolika stupnu: ";
  cin >> po;
  stabulka << TABzacatek << endl;
  for (double x = od; x < po; x++) {
	rad = x / 180.0 * M_PI;
	double si = sin(rad);
	double co = cos(rad);
	stabulka.setf(ios::fixed);
	stabulka 
		<< "<tr><td>" << x 
		<< "</td><td>" << si 
		<< "</td><td>" << co 
		<< "</td></tr>" << endl;
  } // for (double x = od; x < po; x++)
  stabulka << TABkonec << endl;
  return 0;
} // int main()